
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX	TWI-Befehlsdecoder  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX 
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

.equ 	CMD_Min_val = 0x00    // Befehlsdecoder
.equ 	CMD_Max_val = 0xFE  // Befehlsdecoder
 	


	
TWI_RXD_Decoder:
; Clear Status Flag CMD no hit
;		cbr		, 1<<no_hit
		ldi		XL, Low (TWI_RXB_Data)						; X-Pointer auf Empfangsbuffer stellen
		ldi		XH, High (TWI_RXB_Data)						;  X-Pointer auf Empfangsbuffer stellen
		lds		temp3, ByteCNTR_save
		subi	temp3, 1									;  1x Befehl	
		cbr		SREG_1, 1<<UPDA5							; Lschen UPDA 5 
				
		lds		temp, TWI_RX_CMD		  					; Der zuletzt ausgefhrte Befehl.

    	subi    temp, CMD_Min_val                			; Nullpunkt verschieben
    	cpi     temp, (CMD_Max_val-CMD_Min_val+1)     		; Index auf Maximum prfen
    	brsh    TWI_RXD_Dec_no_hit             		 		; Index zu gross -> Fehler
    	ldi     ZL, low(TWI_RXD_Dec_Tab)     			    ; Tabellenzeiger laden, 16 Bit
    	ldi     ZH, high(TWI_RXD_Dec_Tab)                  	; 		
    	add     zl, temp                      				; Index addieren, 16 Bit
    	ldi     temp, 0                   
    	adc     zh, temp
    	ijmp                                				; indirekter Sprung
 
TWI_RXD_Dec_no_hit:
;		sbr		, 1<<no_hit
; hier stehen jetzt alle Anweisungen fr den Fall, dass keiner der Vergleiche erfolgreich war
		ret

 

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
; 						 Sprungtabelle						   X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
TWI_RXD_Dec_Tab:
		rjmp	cmd_00
		rjmp	cmd_01
		rjmp	cmd_02
		rjmp	cmd_03
		rjmp	cmd_04
		rjmp	cmd_05
		rjmp	cmd_06
		rjmp	cmd_07
		rjmp	cmd_08
		rjmp	cmd_09
		rjmp	cmd_0A
		rjmp	cmd_0B
		rjmp	cmd_0C
		rjmp	cmd_0D
		rjmp	cmd_0E
		rjmp	cmd_0F


		rjmp	cmd_10
		rjmp	cmd_11
		rjmp	cmd_12
		rjmp	cmd_13
		rjmp	cmd_14
		rjmp	cmd_15
		rjmp	cmd_16
		rjmp	cmd_17
		rjmp	cmd_18
		rjmp	cmd_19
		rjmp	cmd_1A
		rjmp	cmd_1B
		rjmp	cmd_1C
		rjmp	cmd_1D
		rjmp	cmd_1E
		rjmp	cmd_1F

		rjmp	cmd_20
		rjmp	cmd_21		
		rjmp	cmd_22
		rjmp	cmd_23
		rjmp	cmd_24
		rjmp	cmd_25
		rjmp	cmd_26
		rjmp	cmd_27
		rjmp	cmd_28
		rjmp	cmd_29
		rjmp	cmd_2A
		rjmp	cmd_2B
		rjmp	cmd_2C
		rjmp	cmd_2D
		rjmp	cmd_2E
		rjmp	cmd_2F


		rjmp	cmd_30
		rjmp	cmd_31
		rjmp	cmd_32
		rjmp	cmd_33
		rjmp	cmd_34
		rjmp	cmd_35
		rjmp	cmd_36
		rjmp	cmd_37
		rjmp	cmd_38
		rjmp	cmd_39
		rjmp	cmd_3A
		rjmp	cmd_3B
		rjmp	cmd_3C
		rjmp	cmd_3D
		rjmp	cmd_3E
		rjmp	cmd_3F


		rjmp	cmd_40
		rjmp	cmd_41
		rjmp	cmd_42
		rjmp	cmd_43
		rjmp	cmd_44
		rjmp	cmd_45
		rjmp	cmd_46
		rjmp	cmd_47
		rjmp	cmd_48
		rjmp	cmd_49
		rjmp	cmd_4A
		rjmp	cmd_4B
		rjmp	cmd_4C
		rjmp	cmd_4D
		rjmp	cmd_4E
		rjmp	cmd_4F


		rjmp	cmd_50
		rjmp	cmd_51
		rjmp	cmd_52
		rjmp	cmd_53
		rjmp	cmd_54
		rjmp	cmd_55
		rjmp	cmd_56
		rjmp	cmd_57
		rjmp	cmd_58
		rjmp	cmd_59
		rjmp	cmd_5A
		rjmp	cmd_5B
		rjmp	cmd_5C
		rjmp	cmd_5D
		rjmp	cmd_5E
		rjmp	cmd_5F

		rjmp	cmd_60
		rjmp	cmd_61
		rjmp	cmd_62
		rjmp	cmd_63
		rjmp	cmd_64
		rjmp	cmd_65
		rjmp	cmd_66
		rjmp	cmd_67
		rjmp	cmd_68
		rjmp	cmd_69
		rjmp	cmd_6A
		rjmp	cmd_6B
		rjmp	cmd_6C
		rjmp	cmd_6D
		rjmp	cmd_6E
		rjmp	cmd_6F



		rjmp	cmd_70
		rjmp	cmd_71
		rjmp	cmd_72
		rjmp	cmd_73
		rjmp	cmd_74
		rjmp	cmd_75
		rjmp	cmd_76
		rjmp	cmd_77
		rjmp	cmd_78
		rjmp	cmd_79
		rjmp	cmd_7A
		rjmp	cmd_7B
		rjmp	cmd_7C
		rjmp	cmd_7D
		rjmp	cmd_7E
		rjmp	cmd_7F


		rjmp	cmd_80
		rjmp	cmd_81
		rjmp	cmd_82
		rjmp	cmd_83
		rjmp	cmd_84
		rjmp	cmd_85
		rjmp	cmd_86
		rjmp	cmd_87
		rjmp	cmd_88
		rjmp	cmd_89
		rjmp	cmd_8A
		rjmp	cmd_8B
		rjmp	cmd_8C
		rjmp	cmd_8D
		rjmp	cmd_8E
		rjmp	cmd_8F


		rjmp	cmd_90
		rjmp	cmd_91
		rjmp	cmd_92
		rjmp	cmd_93
		rjmp	cmd_94
		rjmp	cmd_95
		rjmp	cmd_96
		rjmp	cmd_97
		rjmp	cmd_98
		rjmp	cmd_99
		rjmp	cmd_9A
		rjmp	cmd_9B
		rjmp	cmd_9C
		rjmp	cmd_9D
		rjmp	cmd_9E
		rjmp	cmd_9F


		rjmp	cmd_A0
		rjmp	cmd_A1
		rjmp	cmd_A2
		rjmp	cmd_A3
		rjmp	cmd_A4
		rjmp	cmd_A5
		rjmp	cmd_A6
		rjmp	cmd_A7
		rjmp	cmd_A8
		rjmp	cmd_A9
		rjmp	cmd_AA
		rjmp	cmd_AB
		rjmp	cmd_AC
		rjmp	cmd_AD
		rjmp	cmd_AE
		rjmp	cmd_AF


		rjmp	cmd_B0
		rjmp	cmd_B1
		rjmp	cmd_B2
		rjmp	cmd_B3
		rjmp	cmd_B4
		rjmp	cmd_B5
		rjmp	cmd_B6
		rjmp	cmd_B7
		rjmp	cmd_B8
		rjmp	cmd_B9
		rjmp	cmd_BA
		rjmp	cmd_BB
		rjmp	cmd_BC
		rjmp	cmd_BD
		rjmp	cmd_BE
		rjmp	cmd_BF


		rjmp	cmd_C0
		rjmp	cmd_C1
		rjmp	cmd_C2
		rjmp	cmd_C3
		rjmp	cmd_C4
		rjmp	cmd_C5
		rjmp	cmd_C6
		rjmp	cmd_C7
		rjmp	cmd_C8
		rjmp	cmd_C9
		rjmp	cmd_CA
		rjmp	cmd_CB
		rjmp	cmd_CC
		rjmp	cmd_CD
		rjmp	cmd_CE
		rjmp	cmd_CF


		rjmp	cmd_D0
		rjmp	cmd_D1
		rjmp	cmd_D2
		rjmp	cmd_D3
		rjmp	cmd_D4
		rjmp	cmd_D5
		rjmp	cmd_D6
		rjmp	cmd_D7
		rjmp	cmd_D8
		rjmp	cmd_D9
		rjmp	cmd_DA
		rjmp	cmd_DB
		rjmp	cmd_DC
		rjmp	cmd_DD
		rjmp	cmd_DE
		rjmp	cmd_DF


		rjmp	cmd_E0
		rjmp	cmd_E1
		rjmp	cmd_E2
		rjmp	cmd_E3
		rjmp	cmd_E4
		rjmp	cmd_E5
		rjmp	cmd_E6
		rjmp	cmd_E7
		rjmp	cmd_E8
		rjmp	cmd_E9
		rjmp	cmd_EA
		rjmp	cmd_EB
		rjmp	cmd_EC
		rjmp	cmd_ED
		rjmp	cmd_EE
		rjmp	cmd_EF


		rjmp	cmd_F0
		rjmp	cmd_F1
		rjmp	cmd_F2
		rjmp	cmd_F3
		rjmp	cmd_F4
		rjmp	cmd_F5
		rjmp	cmd_F6
		rjmp	cmd_F7
		rjmp	cmd_F8
		rjmp	cmd_F9
		rjmp	cmd_FA
		rjmp	cmd_FB
		rjmp	cmd_FC
		rjmp	cmd_FD
		rjmp	cmd_FE
		rjmp	cmd_FF







;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

cmd_00:
; Magic Command :-)
		ld		temp, X+				// 
		rcall	RXD_DEC_BC_TST			// Autoincrement Simulation
		sbrc	SREG_1, UPDA5			// 
	ret



cmd_01:
		ld		temp, X+				// Lade aus Empfangsbuffer OCR_CH_1 Wert 
		sts		OCR_Ch_01_SRAM, temp	// geladenen Wert im SRAM Ablegen
		mov		OCR_Ch_1, temp
		rcall	RXD_DEC_BC_TST			// Autoincrement Simulation
		sbrc	SREG_1, UPDA5			// 
	ret

cmd_02:
		ld		temp, X+
		sts		OCR_Ch_02_SRAM, temp
		mov		OCR_Ch_2, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_03:
		ld		temp, X+
		sts		OCR_Ch_03_SRAM, temp
		mov		OCR_Ch_3, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_04:
		ld		temp, X+
		sts		OCR_Ch_04_SRAM, temp
		mov		OCR_Ch_4, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_05:
		ld		temp, X+
		sts		OCR_Ch_05_SRAM, temp
		mov		OCR_Ch_5, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_06:
		ld		temp, X+
		sts		OCR_Ch_06_SRAM, temp
		mov		OCR_Ch_6, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_07:
		ld		temp, X+
		sts		OCR_Ch_07_SRAM, temp
		mov		OCR_Ch_7, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_08:
		ld		temp, X+
		sts		OCR_Ch_08_SRAM, temp
		mov		OCR_Ch_8, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_09:
		ld		temp, X+
		sts		OCR_Ch_09_SRAM, temp
		mov		OCR_Ch_9, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0A:
		ld		temp, X+
		sts		OCR_Ch_10_SRAM, temp
		mov		OCR_Ch_10, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0B:
		ld		temp, X+
		sts		OCR_Ch_11_SRAM, temp
		mov		OCR_Ch_11, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0C:
		ld		temp, X+
		sts		OCR_Ch_12_SRAM, temp
		mov		OCR_Ch_12, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0D:
		ld		temp, X+
		sts		OCR_Ch_13_SRAM, temp
		mov		OCR_Ch_13, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0E:
		ld		temp, X+
		sts		OCR_Ch_14_SRAM, temp
		mov		OCR_Ch_14, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_0F:
		ld		temp, X+
		sts		OCR_Ch_15_SRAM, temp
		mov		OCR_Ch_15, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret


cmd_10:
		ld		temp, X+
		sts		OCR_Ch_16_SRAM, temp
		mov		OCR_Ch_16, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5		
	ret
	
; OCR1A Werte
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cmd_11:
; High_Byte laden
		ld		temp, X+
		sts		OCR_Ch_OC1AH_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5	
	ret
	
		
cmd_12:
; Low_byte laden
		ld		temp, X+
		sts		OCR_Ch_OC1AL_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbr		SREG_3, 1<<UPDA30
		sbrc	SREG_1, UPDA5
	
	ret

; OCR1B Werte
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cmd_13:
; High_Byte laden
		ld		temp, X+
		sts		OCR_Ch_OC1BH_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5	
	ret


cmd_14:
; Low_byte laden
		ld		temp, X+
		sts		OCR_Ch_OC1BL_SRAM, temp
		rcall	RXD_DEC_BC_TST					// Autoincrement Simulation
		sbr		SREG_3, 1<<UPDA31
		sbrc	SREG_1, UPDA5
	ret

;***********************************
;*   Hardware Settings
;***********************************

cmd_15:
		ld		temp, X+
		sts		Control_Reg_SRAM, temp
		rcall	RXD_DEC_BC_TST					// Autoincrement Simulation
		sbrc	SREG_1, UPDA5
	ret


cmd_16:											; PWM_CNTR_ADDR
		ld		temp, X+
		andi	temp, (1<<TWA6|1<<TWA5|1<<TWA4|1<<TWA3|1<<TWA2|1<<TWA1|1<<TWA0|0<<TWGCE)
		out		TWAR, temp
		sts		PWM_CNTR_ADDR_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret

cmd_17:											; Clock Select Software PWM. TCCR2 CS
		ld		temp, X+				
		in		temp2, TCCR2
		andi	temp2, (1<<WGM20)|(1<<COM21)|(1<<WGM21)|(1<<COM20)|(0<<CS22)|(0<<CS21)|(0<<CS20)
		andi	temp, (0<<WGM20)|(0<<COM21)|(0<<WGM21)|(0<<COM20)|(1<<CS22)|(1<<CS21)|(1<<CS20)
		or		temp, temp2
		out		TCCR2, temp
		sts		CS_Soft_PWM_SRAM, temp 
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret


cmd_18:											; Timer Counter1 , TCCR1B	// Clock Select for 16-Bit HW PWM

		ld		temp, X+
		in		temp2, TCCR1B
		andi	temp2, (1<<ICNC1)|(1<<ICES1)|(1<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10)  //CS-> .max 5
		andi	temp,  (0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(1<<CS12)|(1<<CS11)|(1<<CS10)  //CS-> .max 5
		or		temp, temp2
		out		TCCR1B, temp
		sts		CS_HW_PWM_16_SRAM,temp 				
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret


cmd_19:		; Timer Counter1 ICR Value load.
		ld		temp, X+
		sts		Res_HW_PWM_HB_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret



cmd_1A:	
		ld		temp, X+
		sts		Res_HW_PWM_LB_SRAM, temp 
		rcall	RXD_DEC_BC_TST
		sbr		SREG_3, 1<<UPDA32
		sbrc	SREG_1, UPDA5
	ret




cmd_1B:				; Software PWM- Resolution
		ld		temp, X+
		mov		PWM_Cnt_Top, temp
		sts		Res_Soft_PWM_SRAM, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret



cmd_1C:      ; PWM Speed vs. Programm Berechnungen					// Bestimmt mit unter die Softw. PWM- Geschwindigkeit 
		ld		temp, X+
		sts		PWM_vs_CALC_SRAM, temp 
		out		OCR2, temp
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret


cmd_1D:
		ld		temp, X+										
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5
	ret


cmd_1E:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret




cmd_1F:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_20:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_21:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_22:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_23:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_24:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_25:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_26:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_27:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_28:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_29:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2A:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2B:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2C:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2D:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2E:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_2F:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret	
	
cmd_30:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_31:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_32:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_33:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_34:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_35:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_36:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_37:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_38:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_39:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_3A:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_3B:	
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret
				
cmd_3C:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_3D:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_3E:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_3F:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret	
	
cmd_40:
		ld		temp, X+
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret



cmd_41:
cmd_42:
cmd_43:
cmd_44:
cmd_45:
cmd_46:
cmd_47:
cmd_48:
cmd_49:
cmd_4A:
cmd_4B:
cmd_4C:
cmd_4D:
cmd_4E:
cmd_4F:
	
	
cmd_50:
cmd_51:
cmd_52:
cmd_53:
cmd_54:
cmd_55:
cmd_56:
cmd_57:
cmd_58:
cmd_59:
cmd_5A:
cmd_5B:
cmd_5C:
cmd_5D:
cmd_5E:
cmd_5F:		

	
cmd_60:

cmd_61:
cmd_62:
cmd_63:
cmd_64:
cmd_65:
cmd_66:
cmd_67:
cmd_68:
cmd_69:
cmd_6A:
cmd_6B:
cmd_6C:
cmd_6D:
cmd_6E:
cmd_6F:
	
	
	
cmd_70:
cmd_71:
cmd_72:
cmd_73:
cmd_74:
cmd_75:
cmd_76:
cmd_77:
cmd_78:
cmd_79:
cmd_7A:
cmd_7B:
cmd_7C:
cmd_7D:
cmd_7E:
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret
cmd_7F:
		rcall	RXD_DEC_BC_TST
		sbrc	SREG_1, UPDA5									
	ret

cmd_80:


	ret								
	ret
;*********************************************************
;* Bis CMD 0x80  ist die Autoincrement Funktion aktiv	 *
;* ab CMD 0x81 kommen die Befehle ohne Autoincrement     *
;*********************************************************
//***********************************************************					
// Um Autoincrement abzuschalten mssen die Folgenden Zeilen 
// aus einem Befehl(CMD_XX) ausgelassen werden:
// 		rcall	RXD_DEC_BC_TST
//		sbrc	SREG_1, UPDA5
//	ohne diese Zeilen ist die Autoincrement Funktion inaktiv
//************************************************************ 

cmd_81:
cmd_82:
cmd_83:
cmd_84:
cmd_85:
cmd_86:
cmd_87:
cmd_88:
cmd_89:
cmd_8A:
cmd_8B:
cmd_8C:
cmd_8D:
cmd_8E:
cmd_8F:
	
	
cmd_90:
cmd_91:
cmd_92:
cmd_93:
cmd_94:
cmd_95:
cmd_96:
cmd_97:
cmd_98:
cmd_99:
cmd_9A:
cmd_9B:
cmd_9C:
cmd_9D:
cmd_9E:
cmd_9F:			
	
	
cmd_A0:
cmd_A1:
cmd_A2:
cmd_A3:
cmd_A4:
cmd_A5:
cmd_A6:
cmd_A7:
cmd_A8:
cmd_A9:
cmd_AA:
cmd_AB:
cmd_AC:
cmd_AD:
cmd_AE:
cmd_AF:
	
	
cmd_B0:
cmd_B1:
cmd_B2:
cmd_B3:
cmd_B4:
cmd_B5:
cmd_B6:
cmd_B7:
cmd_B8:
cmd_B9:
cmd_BA:
cmd_BB:
cmd_BC:
cmd_BD:



cmd_BE:								// Daten im EEPROM Speichern
; X- Pointer ist Buffer Pointer
; High, Low_Byte der EEPROM Adressen Pointer
; Y- Pointer ist der Referenzwert fr die hchste EEPROM Adresse

		ld		High_Byte, X+		// EEPROM Adresse High_Byte
		dec		temp3					// Bytecounter -1 wegen YH
		Breq	cmd_BE_BC_err				// ByteCounter drfte nicht 0 sein weil die Low_Byte Adresse nicht geschrieben wurde

		ld		Low_Byte, X+					// EEPROM Adresse Low_Byte 
		dec		temp3							// Bytecounter -1 wegen YL
		Breq	cmd_BE_BC_err					// ByteCounter drfte nicht 0 sein weil die Daten nicht geschrieben wurde

		subi	Low_Byte, Low (-TWI_EEPROM)		// Addition mit 16-Bit Konstante
		sbci	High_Byte, High (-TWI_EEPROM)	// Addition mit 16-Bit Konstante

		ldi		YL, Low (CMD_WSP_EEP_END)			// Parameter oder CMD Workspace ende
		ldi		YH, High (CMD_WSP_EEP_END)		// Parameter oder CMD Workspace ende

		cp		Low_Byte, YL					// 
		cpc		High_Byte, YH					// 
		Brlo	cmd_BE_BC_err					// Der Wert darf nicht im Bereich des CMD Workspace_EEP liegen

		ldi		YL, Low (E2END)					// EEPROM Ende
		ldi		YH, High (E2END)				// EEPROM Ende
		
	
cmd_BE_loop:
		WDR										// Den Wachhund nicht vergessen, sonst verhungert er :-)
		dec		temp3							// Wenn der Zhler gleich 0 ist dann wurden alle Daten aus dem Empfansbuffer geschrieben
		Breq	cmd_BE_BC_err					// in den SRAM kopiert.	
		cp		Low_Byte, YL				// EEPROM Ende erreicht
		cpc		High_Byte, YH				// EEPROM Ende erreicht
		Breq	cmd_BE_LEA				// letzte EEPROM Adresse wurde erreicht
		ld		temp, X+				// Byte aus RX-Buffer laden
		rcall	EEP_Byte_Save		// Im EEPROM Abspeichern
		adiw	Low_Byte, 1			// EEPROM Pointer erhhen (+1)
		rjmp	cmd_BE_loop
	ret								// ByteCounter Leer es gibt nichts mehr zum schreiben
cmd_BE_BC_err:
	ret
cmd_BE_LEA:							// Das letzte Byte schreiben und aussteigen
		ld		temp, X+				// Byte aus RX-Buffer laden
		rcall	EEP_Byte_Save
	ret

																			

cmd_BF:								// Daten im SRAM Datenspeicherbereich speichern
; Schreibschutz fr STACK- Bereich integriert, ohne Rckmeldung in Form eines Flags
; Somit 
		ld		YH, X+				// Zeigt auf High_Byte
		dec		temp3				// Bytecounter -1 wegen YH
		Breq	cmd_BF_BC_err		// ByteCounter drfte nicht 0 sein weil die Low_Byte Adresse nicht geschrieben wurde

		ld		YL, X+				// Adresse Low_Byte im SRAM	
		dec		temp3				// Bytecounter -1 wegen YL
		Breq	cmd_BF_BC_err		// ByteCounter drfte nicht 0 sein weil die Daten nicht geschrieben wurde

		subi	YL, Low (-SRAM_DS)	// Addition mit 16-Bit Konstante
		sbci	YH, High(-SRAM_DS)	// Addition mit 16-Bit Konstante

		ldi		Low_Byte, Low (SRAM_DS_END)
		ldi		High_byte, High (SRAM_DS_END)

cmd_BF_loop:
		cp		YL, Low_Byte		// SRAM Daten Speicher Top
		cpc		YH, High_Byte		// SRAM Daten Speicher Top
		Brsh	cmd_BF_BC_err		// wenn der STACK- Bereich erreicht wurde, dann schreiben abbrechen.		
		ld		temp, X+			// Byte aus RX-Buffer laden
		st		Y+, temp			// Byte im TX-Buffer speichern
		dec		temp3				// Wenn der Zhler gleich 0 ist dann wurden alle Daten aus dem Empfansbuffer
		Brne	cmd_BF_loop			// in den SRAM kopiert.

cmd_BF_BC_err:
; Eventuelle rckmeldung wegen eines versuchs in den STACK- Bereich zu schreiben
	ret
	
	
cmd_C0:	// Hardware Settings abspeichern											
		ld		temp, X+									// Schreibbesttigung
		cpi		temp, 'S'
		Brne	cmd_C0_A
		rcall	EEP_HW_set_WR
cmd_C0_A:	
	ret


cmd_C1:	// PWM- Werte Abspeichern
		ld		temp, X+									// Schreibbesttigung
		cpi		temp, 'S'									
		Brne	cmd_C1_A
		rcall	EEP_PWM_val_WR
cmd_C1_A:								
	ret	


cmd_C2:		// PWM Kanal 1 Save 
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C2_A
		ldi		Low_Byte, Low (OCR_Ch_01_EEP)				// EEPROM- Speicherpointer Low_Byte
		ldi		High_Byte, High (OCR_Ch_01_EEP)				// EEPROM- Speicherpointer High_Byte
		lds		temp, OCR_CH_01_SRAM						// Aktuellen PWM Channel 1 Wert laden
		rcall	EEP_Byte_Save								// Wert im EEPROM abspeichern		
	ret				
cmd_C2_A:													// Wenn der Suffix 'S' nicht empfangen wurde
	ret


cmd_C3:		// PWM Kanal 2 Save  
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C3_A
		ldi		Low_Byte, Low (OCR_Ch_02_EEP)
		ldi		High_Byte, High (OCR_Ch_02_EEP)
		lds		temp, OCR_CH_02_SRAM
		rcall	EEP_Byte_Save
	ret					
cmd_C3_A:													// Wenn der Suffix 'S' nicht empfangen wurde
	ret


cmd_C4:		// PWM Kanal 3 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C4_A
		ldi		Low_Byte, Low (OCR_CH_03_EEP)
		ldi		High_Byte, High (OCR_CH_03_EEP)
		lds		temp, OCR_CH_03_SRAM
		rcall	EEP_Byte_Save
	ret					
cmd_C4_A:													// Wenn der Suffix 'S' nicht empfangen wurde
	ret


cmd_C5:		// PWM Kanal 4 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C5_A
		ldi		Low_Byte, Low (OCR_Ch_04_EEP)
		ldi		High_Byte, High (OCR_Ch_04_EEP)
		lds		temp, OCR_CH_04_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_C5_A:				
	ret


cmd_C6:		// PWM Kanal 5 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C6_A
		ldi		Low_Byte, Low (OCR_Ch_05_EEP)
		ldi		High_Byte, High (OCR_Ch_05_EEP)
		lds		temp, OCR_CH_05_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_C6_A:				
	ret					


cmd_C7:		// PWM Kanal 6 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C7_A
		ldi		Low_Byte, Low (OCR_Ch_06_EEP)
		ldi		High_Byte, High (OCR_Ch_06_EEP)
		lds		temp, OCR_CH_06_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_C7_A:				
	ret					


cmd_C8:		// PWM Kanal 7 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C8_A
		ldi		Low_Byte, Low (OCR_Ch_07_EEP)
		ldi		High_Byte, High (OCR_Ch_07_EEP)
		lds		temp, OCR_CH_07_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_C8_A:				
	ret					

	
cmd_C9:		// PWM Kanal 8 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_C9_A
		ldi		Low_Byte, Low (OCR_Ch_08_EEP)
		ldi		High_Byte, High (OCR_Ch_08_EEP)
		lds		temp, OCR_CH_08_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_C9_A:				
	ret


cmd_CA:		// PWM Kanal 9 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CA_A
		ldi		Low_Byte, Low (OCR_Ch_09_EEP)
		ldi		High_Byte, High (OCR_Ch_09_EEP)
		lds		temp, OCR_CH_09_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CA_A:				
	ret


cmd_CB:		// PWM Kanal 10 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CB_A
		ldi		Low_Byte, Low (OCR_Ch_10_EEP)
		ldi		High_Byte, High (OCR_Ch_10_EEP)
		lds		temp, OCR_CH_10_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CB_A:				
	ret


cmd_CC:		// PWM Kanal 11 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CC_A
		ldi		Low_Byte, Low (OCR_Ch_11_EEP)
		ldi		High_Byte, High (OCR_Ch_11_EEP)
		lds		temp, OCR_CH_11_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CC_A:				
	ret


cmd_CD:		// PWM Kanal 12 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CD_A
		ldi		Low_Byte, Low (OCR_Ch_12_EEP)
		ldi		High_Byte, High (OCR_Ch_12_EEP)
		lds		temp, OCR_CH_12_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CD_A:				
	ret



cmd_CE:		// PWM Kanal 13 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CE_A
		ldi		Low_Byte, Low (OCR_Ch_13_EEP)
		ldi		High_Byte, High (OCR_Ch_13_EEP)
		lds		temp, OCR_CH_13_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CE_A:				
	ret


cmd_CF:		// PWM Kanal 14 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_CF_A
		ldi		Low_Byte, Low (OCR_Ch_14_EEP)
		ldi		High_Byte, High (OCR_Ch_14_EEP)
		lds		temp, OCR_CH_14_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_CF_A:				
	ret	
	
		
cmd_D0:		// PWM Kanal 15 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D0_A
		ldi		Low_Byte, Low (OCR_Ch_15_EEP)
		ldi		High_Byte, High (OCR_Ch_15_EEP)
		lds		temp, OCR_CH_15_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D0_A:				
	ret


cmd_D1:		// PWM Kanal 16 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D1_A
		ldi		Low_Byte, Low (OCR_Ch_16_EEP)
		ldi		High_Byte, High (OCR_Ch_16_EEP)
		lds		temp, OCR_CH_16_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D1_A:				
	ret


cmd_D2:		// PWM Kanal 17 HB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D2_A
		ldi		Low_Byte, Low (OCR_Ch_OC1AH_EEP)
		ldi		High_Byte, High (OCR_Ch_OC1AH_EEP)
		lds		temp, OCR_Ch_OC1AH_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D2_A:				
	ret


cmd_D3:		// PWM Kanal 17 LB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D3_A
		ldi		Low_Byte, Low (OCR_Ch_OC1AL_EEP)
		ldi		High_Byte, High (OCR_Ch_OC1AL_EEP)
		lds		temp, OCR_Ch_OC1AL_SRAM 	
		rcall	EEP_Byte_Save
	ret					
cmd_D3_A:				
	ret


cmd_D4:		// PWM Kanal 18 HB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D4_A
		ldi		Low_Byte, Low (OCR_Ch_OC1BH_EEP)
		ldi		High_Byte, High (OCR_Ch_OC1BH_EEP)
		lds		temp, OCR_Ch_OC1BH_SRAM 	
		rcall	EEP_Byte_Save
	ret					
cmd_D4_A:				
	ret


cmd_D5:		// PWM Kanal 18 LB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D5_A
		ldi		Low_Byte, Low (OCR_Ch_OC1BL_EEP)
		ldi		High_Byte, High (OCR_Ch_OC1BL_EEP)
		lds		temp, OCR_Ch_OC1BL_SRAM 	
		rcall	EEP_Byte_Save
	ret					
cmd_D5_A:				
	ret



cmd_D6:		//	Control_Reg Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D6_A
		ldi		Low_Byte, Low (Control_Reg_EEP)
		ldi		High_Byte, High (Control_Reg_EEP)
		lds		temp, Control_Reg_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D6_A:				
	ret					


cmd_D7:		//	PWM_CNTR_ADDR Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D7_A
		ldi		Low_Byte, Low (PWM_CNTR_ADDR_EEP)
		ldi		High_Byte, High (PWM_CNTR_ADDR_EEP)
		lds		temp, PWM_CNTR_ADDR_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D7_A:				
	ret					



cmd_D8:		//	CS_Soft_PWM Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D8_A
		ldi		Low_Byte, Low (CS_Soft_PWM_EEP)
		ldi		High_Byte, High (CS_Soft_PWM_EEP)
		lds		temp, CS_Soft_PWM_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D8_A:				
	ret					


cmd_D9:		//	CS_HW_PWM_16 Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_D9_A
		ldi		Low_Byte, Low (CS_HW_PWM_16_EEP)
		ldi		High_Byte, High (CS_HW_PWM_16_EEP)
		lds		temp, CS_HW_PWM_16_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_D9_A:				
	ret					


cmd_DA:		//	Res_HW_PWM_HB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_DA_A
		ldi		Low_Byte, Low (Res_HW_PWM_HB_EEP)
		ldi		High_Byte, High (Res_HW_PWM_HB_EEP)
		lds		temp, Res_HW_PWM_HB_SRAM  	
		rcall	EEP_Byte_Save
	ret					
cmd_DA_A:				
	ret					


cmd_DB:		//	Res_HW_PWM_LB Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_DB_A
		ldi		Low_Byte, Low (Res_HW_PWM_LB_EEP)
		ldi		High_Byte, High (Res_HW_PWM_LB_EEP)
		lds		temp, Res_HW_PWM_LB_SRAM  	
		rcall	EEP_Byte_Save
	ret					
cmd_DB_A:				
	ret					


cmd_DC:		//	Res_Soft_PWM Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_DC_A
		ldi		Low_Byte, Low (Res_Soft_PWM_EEP)
		ldi		High_Byte, High (Res_Soft_PWM_EEP)
		lds		temp, Res_Soft_PWM_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_DC_A:				
	ret					


cmd_DD:		//	PWM_vs_CALC Save
		ld		temp, X+
		cpi		temp, 'S'
		Brne	cmd_DD_A
		ldi		Low_Byte, Low (PWM_vs_CALC_EEP)
		ldi		High_Byte, High (PWM_vs_CALC_EEP)
		lds		temp, PWM_vs_CALC_SRAM	
		rcall	EEP_Byte_Save
	ret					
cmd_DD_A:				
	ret					





cmd_DE:		
		ld		temp, X+
		cpi		temp, 'S'












cmd_DF:
cmd_E0:
cmd_E1:
cmd_E2:
cmd_E3:
cmd_E4:
cmd_E5:
cmd_E6:
cmd_E7:
cmd_E8:
cmd_E9:
cmd_EA:
cmd_EB:
cmd_EC:
cmd_ED:
cmd_EE:
cmd_EF:
	
	
cmd_F0:
cmd_F1:
cmd_F2:
cmd_F3:
cmd_F4:
cmd_F5:
cmd_F6:
cmd_F7:
cmd_F8:
cmd_F9:
cmd_FA:
cmd_FB:
cmd_FC:
cmd_FD:
cmd_FE:
	ret

cmd_FF:			// Gibts nicht	Es sind nur die Befehle 00- FE in Dekodierbereich					

	ret




; Autoincrement Prfsystem
; Ist temp3 =0 so wird weiteres
; laden aus dem Buffer unterbunden
RXD_DEC_BC_TST:				// Data Counter test
		dec		temp3
		tst		temp3
		Breq	RXD_DEC_BC_TST_1
	ret
RXD_DEC_BC_TST_1:
		sbr		SREG_1, 1<<UPDA5		// Wird gesetzt wenn der Packetlngenzhler=0 ist.
	ret									// Somit wird die Auswertung der empfangenen Daten abgeschlossen.
